PostgreSQL 9.6.5 Documentation
Prev | Up |  | Next

# pg_rewind

## Name

pg_rewind -- synchronize a PostgreSQL data directory with another data directory that was forked from it

## Synopsis

`pg_rewind` [`option`...] {`-D` | `--target-pgdata`}`directory` {`--source-pgdata=`directory`` | `--source-server=`connstr``}

## Description

pg_rewind is a tool for synchronizing a PostgreSQL cluster with another copy of the same cluster, after the clusters' timelines have diverged. A typical scenario is to bring an old master server back online after failover as a standby that follows the new master.

The result is equivalent to replacing the target data directory with the source one. Only changed blocks from relation files are copied; all other files are copied in full, including configuration files. The advantage of pg_rewind over taking a new base backup, or tools like rsync, is that pg_rewind does not require reading through unchanged blocks in the cluster. This makes it a lot faster when the database is large and only a small fraction of blocks differ between the clusters.

pg_rewind examines the timeline histories of the source and target clusters to determine the point where they diverged, and expects to find WAL in the target cluster's `pg_xlog` directory reaching all the way back to the point of divergence. The point of divergence can be found either on the target timeline, the source timeline, or their common ancestor. In the typical failover scenario where the target cluster was shut down soon after the divergence, this is not a problem, but if the target cluster ran for a long time after the divergence, the old WAL files might no longer be present. In that case, they can be manually copied from the WAL archive to the `pg_xlog` directory, or fetched on startup by configuring `recovery.conf`. The use of pg_rewind is not limited to failover, e.g. a standby server can be promoted, run some write transactions, and then rewinded to become a standby again.

When the target server is started for the first time after running pg_rewind, it will go into recovery mode and replay all WAL generated in the source server after the point of divergence. If some of the WAL was no longer available in the source server when pg_rewind was run, and therefore could not be copied by the pg_rewind session, it must be made available when the target server is started. This can be done by creating a `recovery.conf` file in the target data directory with a suitable `restore_command`.

pg_rewind requires that the target server either has the wal_log_hints option enabled in `postgresql.conf` or data checksums enabled when the cluster was initialized with initdb. Neither of these are currently on by default. full_page_writes must also be set to `on`, but is enabled by default.

## Options

pg_rewind accepts the following command-line arguments:

`-D `directory``
`--target-pgdata=`directory``

  This option specifies the target data directory that is synchronized with the source. The target server must be shut down cleanly before running pg_rewind

`--source-pgdata=`directory``

  Specifies the file system path to the data directory of the source server to synchronize the target with. This option requires the source server to be cleanly shut down.

`--source-server=`connstr``

  Specifies a libpq connection string to connect to the source PostgreSQL server to synchronize the target with. The connection must be a normal (non-replication) connection with superuser access. This option requires the source server to be running and not in recovery mode.

`-n`
`--dry-run`

  Do everything except actually modifying the target directory.

`-P`
`--progress`

  Enables progress reporting. Turning this on will deliver an approximate progress report while copying data from the source cluster.

`--debug`

  Print verbose debugging output that is mostly useful for developers debugging pg_rewind.

`-V`
`--version`

  Display version information, then exit.

`-?`
`--help`

  Show help, then exit.

## Environment

When `--source-server` option is used, pg_rewind also uses the environment variables supported by libpq (see Section 32.14).

## Notes

### How it works

The basic idea is to copy all file system-level changes from the source cluster to the target cluster:

1. Scan the WAL log of the target cluster, starting from the last checkpoint before the point where the source cluster's timeline history forked off from the target cluster. For each WAL record, record each data block that was touched. This yields a list of all the data blocks that were changed in the target cluster, after the source cluster forked off.

2. Copy all those changed blocks from the source cluster to the target cluster, either using direct file system access (`--source-pgdata`) or SQL (`--source-server`).

3. Copy all other files such as `pg_clog` and configuration files from the source cluster to the target cluster (everything except the relation files).

4. Apply the WAL from the source cluster, starting from the checkpoint created at failover. (Strictly speaking, pg_rewind doesn't apply the WAL, it just creates a backup label file that makes PostgreSQL start by replaying all WAL from that checkpoint forward.)

Prev | Home | Next
pg_resetxlog | Up | pg_test_fsync